;Przykładowy program POOL, możesz go dowolnie
;używać i modyfikować na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

;klasa bazowa dla żółwi rysujących fraktal
to painter
  ;prototyp funkcji obliczjącej fraktal
  to formula :real :img :depth output 0 end
  ;prototyp funkcji skalującej kolor
  to fcolor :idx output 0 end
  ;prototyp funkcji liczącej współczynnik skalowania koloru
  to cscale output 1 end
  ;prototyp funkcji wyznaczającej maks. liczbę iteracji
  to depth :s output 1 end

  to fxy :x :y
    let "c round :cscale * fcolor formula :x :y :depth
    ifelse :c >= 1 && :c < 1000 [op :c] [op {0 0 0 0}]
  end

  ;funkcja odmalowania okna
  to do_render :walls :depth
    "depth := depth :depth
    "cscale := cscale
    while not :break [
      lock "lines [
        ifelse count :lines > 0
        [let "y dequeue :lines]
        [break]
      ]
      :walls,3 := :y
      :walls,4 := :y
      (render $fxy 100 :walls)
    ]
    signal "tstop
  end

  let "cscale 1 ;skala: wartość w punkcie -> kolor
  pu ht ;podnieś pisak i ukryj ikonę żółwia
end
;--- koniec klasy painter ---

;klasa uruchamiająca obliczenia i mierząca czas
to tmeasure
  to start :data
    wait 30 ;czekaj na częste powtórzenia wywołań
    if not (:break || empty? :t) [
      (print "|start render...|)
      let "ms timemilli
      lock "t [(do_render :data,1 :data,2) @ :t]
      (waitsignal "tstop :t)
      (print "|render time:| 0.001 * (timemilli - :ms))
    ]
    signal "ready
  end
  pu ht signal "ready
end
;--- koniec klasy tmeasure ---

shared [t break lines]
"lines := [] ;lista współrzędnych Y kolejnych linii obrazu
"t := [] ;lista żółwi malujących fraktal
"break := false
ht pu

"u := (newt $tmeasure) ;żółw sterujący obliczeniami

;obsługa zdarzenia zmiany pozycji ścian (odmalowuje fraktal)
to onworldchanged :walls
  if empty? :t [stop]

  "break := true
  (waitsignal "ready :u)
  "break := false

  let "ymax :walls,3
  let "ymin :walls,4
  let "dy 1 / :pool_cfg,"scale_y
  lock "lines [
    "lines := []
    for [y [:ymax + :dy] :ymin -:dy] [queue :lines :y]
  ]

  cs (start array :walls :pool_cfg,"scale_x) @ :u
end

